#include "cpluslib/holder.h"

ObjectHolder::ObjectHolder()
{ }

ObjectHolder::~ObjectHolder()
{
    while (!list.empty()) {
        delete list.back();
        list.pop_back();
    }
}

void
ObjectHolder::doAdd(Object* p)
{
    try {
        list.push_back(p);
    }
    catch(...) {
        delete p;
        throw;
    }
}
