#ifndef STREU_CPLUSLIB_HOLDER_H_INCLUDED
#define STREU_CPLUSLIB_HOLDER_H_INCLUDED

#include <vector>
#include "cpluslib/config.h"
#include "cpluslib/object.h"

class ObjectHolder : public Object {
    std::vector<Object*> list;
    void doAdd(Object* p);
 public:
    ObjectHolder();
    ~ObjectHolder();

    template<class T>
    T& add(T* p) { doAdd(p); return *p; }
};

#endif
